# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from corvic_generated.feature.v1 import space_pb2 as corvic_dot_feature_dot_v1_dot_space__pb2


class SpaceServiceStub(object):
    """SpaceService exports a CRUD api to enable to management of corvic feature spaces.
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.GetSpace = channel.unary_unary(
                '/corvic.feature.v1.SpaceService/GetSpace',
                request_serializer=corvic_dot_feature_dot_v1_dot_space__pb2.GetSpaceRequest.SerializeToString,
                response_deserializer=corvic_dot_feature_dot_v1_dot_space__pb2.GetSpaceResponse.FromString,
                )
        self.CreateSpace = channel.unary_unary(
                '/corvic.feature.v1.SpaceService/CreateSpace',
                request_serializer=corvic_dot_feature_dot_v1_dot_space__pb2.CreateSpaceRequest.SerializeToString,
                response_deserializer=corvic_dot_feature_dot_v1_dot_space__pb2.CreateSpaceResponse.FromString,
                )
        self.DeleteSpace = channel.unary_unary(
                '/corvic.feature.v1.SpaceService/DeleteSpace',
                request_serializer=corvic_dot_feature_dot_v1_dot_space__pb2.DeleteSpaceRequest.SerializeToString,
                response_deserializer=corvic_dot_feature_dot_v1_dot_space__pb2.DeleteSpaceResponse.FromString,
                )
        self.ListSpaces = channel.unary_unary(
                '/corvic.feature.v1.SpaceService/ListSpaces',
                request_serializer=corvic_dot_feature_dot_v1_dot_space__pb2.ListSpacesRequest.SerializeToString,
                response_deserializer=corvic_dot_feature_dot_v1_dot_space__pb2.ListSpacesResponse.FromString,
                )


class SpaceServiceServicer(object):
    """SpaceService exports a CRUD api to enable to management of corvic feature spaces.
    """

    def GetSpace(self, request, context):
        """GetSpace is used to read a space by id, returning NotFound on failure.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def CreateSpace(self, request, context):
        """CreateSpace will create a space. Requires valid ids for the target org and target
        org room.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def DeleteSpace(self, request, context):
        """DeleteSpace is used to delete a space by id, returning NotFound on failure.
        Note: delete is not immediate.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def ListSpaces(self, request, context):
        """ListSpaces list spaces for an org. If a room_id is provided then only the spaces
        for the provided org room are returned.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_SpaceServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'GetSpace': grpc.unary_unary_rpc_method_handler(
                    servicer.GetSpace,
                    request_deserializer=corvic_dot_feature_dot_v1_dot_space__pb2.GetSpaceRequest.FromString,
                    response_serializer=corvic_dot_feature_dot_v1_dot_space__pb2.GetSpaceResponse.SerializeToString,
            ),
            'CreateSpace': grpc.unary_unary_rpc_method_handler(
                    servicer.CreateSpace,
                    request_deserializer=corvic_dot_feature_dot_v1_dot_space__pb2.CreateSpaceRequest.FromString,
                    response_serializer=corvic_dot_feature_dot_v1_dot_space__pb2.CreateSpaceResponse.SerializeToString,
            ),
            'DeleteSpace': grpc.unary_unary_rpc_method_handler(
                    servicer.DeleteSpace,
                    request_deserializer=corvic_dot_feature_dot_v1_dot_space__pb2.DeleteSpaceRequest.FromString,
                    response_serializer=corvic_dot_feature_dot_v1_dot_space__pb2.DeleteSpaceResponse.SerializeToString,
            ),
            'ListSpaces': grpc.unary_unary_rpc_method_handler(
                    servicer.ListSpaces,
                    request_deserializer=corvic_dot_feature_dot_v1_dot_space__pb2.ListSpacesRequest.FromString,
                    response_serializer=corvic_dot_feature_dot_v1_dot_space__pb2.ListSpacesResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'corvic.feature.v1.SpaceService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))


 # This class is part of an EXPERIMENTAL API.
class SpaceService(object):
    """SpaceService exports a CRUD api to enable to management of corvic feature spaces.
    """

    @staticmethod
    def GetSpace(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/corvic.feature.v1.SpaceService/GetSpace',
            corvic_dot_feature_dot_v1_dot_space__pb2.GetSpaceRequest.SerializeToString,
            corvic_dot_feature_dot_v1_dot_space__pb2.GetSpaceResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def CreateSpace(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/corvic.feature.v1.SpaceService/CreateSpace',
            corvic_dot_feature_dot_v1_dot_space__pb2.CreateSpaceRequest.SerializeToString,
            corvic_dot_feature_dot_v1_dot_space__pb2.CreateSpaceResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def DeleteSpace(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/corvic.feature.v1.SpaceService/DeleteSpace',
            corvic_dot_feature_dot_v1_dot_space__pb2.DeleteSpaceRequest.SerializeToString,
            corvic_dot_feature_dot_v1_dot_space__pb2.DeleteSpaceResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)

    @staticmethod
    def ListSpaces(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(request, target, '/corvic.feature.v1.SpaceService/ListSpaces',
            corvic_dot_feature_dot_v1_dot_space__pb2.ListSpacesRequest.SerializeToString,
            corvic_dot_feature_dot_v1_dot_space__pb2.ListSpacesResponse.FromString,
            options, channel_credentials,
            insecure, call_credentials, compression, wait_for_ready, timeout, metadata)
