from google.protobuf import struct_pb2 as _struct_pb2
from google.protobuf.internal import containers as _containers
from google.protobuf.internal import enum_type_wrapper as _enum_type_wrapper
from google.protobuf import descriptor as _descriptor
from google.protobuf import message as _message
from typing import ClassVar as _ClassVar, Iterable as _Iterable, Mapping as _Mapping, Optional as _Optional, Union as _Union

DESCRIPTOR: _descriptor.FileDescriptor

class JoinType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    JOIN_TYPE_UNSPECIFIED: _ClassVar[JoinType]
    JOIN_TYPE_INNER: _ClassVar[JoinType]
    JOIN_TYPE_LEFT_OUTER: _ClassVar[JoinType]

class AggregationType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    AGGREGATION_TYPE_UNSPECIFIED: _ClassVar[AggregationType]
    AGGREGATION_TYPE_COUNT: _ClassVar[AggregationType]
    AGGREGATION_TYPE_AVG: _ClassVar[AggregationType]
    AGGREGATION_TYPE_MODE: _ClassVar[AggregationType]
    AGGREGATION_TYPE_MIN: _ClassVar[AggregationType]
    AGGREGATION_TYPE_MAX: _ClassVar[AggregationType]
    AGGREGATION_TYPE_SUM: _ClassVar[AggregationType]

class LogicalCombination(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    LOGICAL_COMBINATION_UNSPECIFIED: _ClassVar[LogicalCombination]
    LOGICAL_COMBINATION_ANY: _ClassVar[LogicalCombination]
    LOGICAL_COMBINATION_ALL: _ClassVar[LogicalCombination]

class ComparisonType(int, metaclass=_enum_type_wrapper.EnumTypeWrapper):
    __slots__ = ()
    COMPARISON_TYPE_UNSPECIFIED: _ClassVar[ComparisonType]
    COMPARISON_TYPE_EQ: _ClassVar[ComparisonType]
    COMPARISON_TYPE_NE: _ClassVar[ComparisonType]
    COMPARISON_TYPE_LT: _ClassVar[ComparisonType]
    COMPARISON_TYPE_GT: _ClassVar[ComparisonType]
    COMPARISON_TYPE_LE: _ClassVar[ComparisonType]
    COMPARISON_TYPE_GE: _ClassVar[ComparisonType]
JOIN_TYPE_UNSPECIFIED: JoinType
JOIN_TYPE_INNER: JoinType
JOIN_TYPE_LEFT_OUTER: JoinType
AGGREGATION_TYPE_UNSPECIFIED: AggregationType
AGGREGATION_TYPE_COUNT: AggregationType
AGGREGATION_TYPE_AVG: AggregationType
AGGREGATION_TYPE_MODE: AggregationType
AGGREGATION_TYPE_MIN: AggregationType
AGGREGATION_TYPE_MAX: AggregationType
AGGREGATION_TYPE_SUM: AggregationType
LOGICAL_COMBINATION_UNSPECIFIED: LogicalCombination
LOGICAL_COMBINATION_ANY: LogicalCombination
LOGICAL_COMBINATION_ALL: LogicalCombination
COMPARISON_TYPE_UNSPECIFIED: ComparisonType
COMPARISON_TYPE_EQ: ComparisonType
COMPARISON_TYPE_NE: ComparisonType
COMPARISON_TYPE_LT: ComparisonType
COMPARISON_TYPE_GT: ComparisonType
COMPARISON_TYPE_LE: ComparisonType
COMPARISON_TYPE_GE: ComparisonType

class TableComputeOp(_message.Message):
    __slots__ = ("empty", "select_from_staging", "rename_columns", "join", "select_columns", "limit_rows", "filter_rows", "distinct_rows", "update_metadata", "set_metadata", "remove_from_metadata", "update_feature_types", "rollup_by_aggregation")
    EMPTY_FIELD_NUMBER: _ClassVar[int]
    SELECT_FROM_STAGING_FIELD_NUMBER: _ClassVar[int]
    RENAME_COLUMNS_FIELD_NUMBER: _ClassVar[int]
    JOIN_FIELD_NUMBER: _ClassVar[int]
    SELECT_COLUMNS_FIELD_NUMBER: _ClassVar[int]
    LIMIT_ROWS_FIELD_NUMBER: _ClassVar[int]
    FILTER_ROWS_FIELD_NUMBER: _ClassVar[int]
    DISTINCT_ROWS_FIELD_NUMBER: _ClassVar[int]
    UPDATE_METADATA_FIELD_NUMBER: _ClassVar[int]
    SET_METADATA_FIELD_NUMBER: _ClassVar[int]
    REMOVE_FROM_METADATA_FIELD_NUMBER: _ClassVar[int]
    UPDATE_FEATURE_TYPES_FIELD_NUMBER: _ClassVar[int]
    ROLLUP_BY_AGGREGATION_FIELD_NUMBER: _ClassVar[int]
    empty: EmptyOp
    select_from_staging: SelectFromStagingOp
    rename_columns: RenameColumnsOp
    join: JoinOp
    select_columns: SelectColumnsOp
    limit_rows: LimitRowsOp
    filter_rows: FilterRowsOp
    distinct_rows: DistinctRowsOp
    update_metadata: UpdateMetadataOp
    set_metadata: SetMetadataOp
    remove_from_metadata: RemoveFromMetadataOp
    update_feature_types: UpdateFeatureTypesOp
    rollup_by_aggregation: RollupByAggregationOp
    def __init__(self, empty: _Optional[_Union[EmptyOp, _Mapping]] = ..., select_from_staging: _Optional[_Union[SelectFromStagingOp, _Mapping]] = ..., rename_columns: _Optional[_Union[RenameColumnsOp, _Mapping]] = ..., join: _Optional[_Union[JoinOp, _Mapping]] = ..., select_columns: _Optional[_Union[SelectColumnsOp, _Mapping]] = ..., limit_rows: _Optional[_Union[LimitRowsOp, _Mapping]] = ..., filter_rows: _Optional[_Union[FilterRowsOp, _Mapping]] = ..., distinct_rows: _Optional[_Union[DistinctRowsOp, _Mapping]] = ..., update_metadata: _Optional[_Union[UpdateMetadataOp, _Mapping]] = ..., set_metadata: _Optional[_Union[SetMetadataOp, _Mapping]] = ..., remove_from_metadata: _Optional[_Union[RemoveFromMetadataOp, _Mapping]] = ..., update_feature_types: _Optional[_Union[UpdateFeatureTypesOp, _Mapping]] = ..., rollup_by_aggregation: _Optional[_Union[RollupByAggregationOp, _Mapping]] = ...) -> None: ...

class JoinOp(_message.Message):
    __slots__ = ("left_source", "left_join_columns", "right_source", "right_join_columns", "how")
    LEFT_SOURCE_FIELD_NUMBER: _ClassVar[int]
    LEFT_JOIN_COLUMNS_FIELD_NUMBER: _ClassVar[int]
    RIGHT_SOURCE_FIELD_NUMBER: _ClassVar[int]
    RIGHT_JOIN_COLUMNS_FIELD_NUMBER: _ClassVar[int]
    HOW_FIELD_NUMBER: _ClassVar[int]
    left_source: TableComputeOp
    left_join_columns: _containers.RepeatedScalarFieldContainer[str]
    right_source: TableComputeOp
    right_join_columns: _containers.RepeatedScalarFieldContainer[str]
    how: JoinType
    def __init__(self, left_source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., left_join_columns: _Optional[_Iterable[str]] = ..., right_source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., right_join_columns: _Optional[_Iterable[str]] = ..., how: _Optional[_Union[JoinType, str]] = ...) -> None: ...

class RenameColumnsOp(_message.Message):
    __slots__ = ("source", "old_names_to_new")
    class OldNamesToNewEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: str
        def __init__(self, key: _Optional[str] = ..., value: _Optional[str] = ...) -> None: ...
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    OLD_NAMES_TO_NEW_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    old_names_to_new: _containers.ScalarMap[str, str]
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., old_names_to_new: _Optional[_Mapping[str, str]] = ...) -> None: ...

class TextFeatureType(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class CategoricalFeatureType(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class PrimaryKeyFeatureType(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class ForeignKeyFeatureType(_message.Message):
    __slots__ = ("referenced_source_id",)
    REFERENCED_SOURCE_ID_FIELD_NUMBER: _ClassVar[int]
    referenced_source_id: str
    def __init__(self, referenced_source_id: _Optional[str] = ...) -> None: ...

class IdentifierFeatureType(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class NumericalFeatureType(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class MultiCategoricalFeatureType(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class TimestampFeatureType(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class EmbeddingFeatureType(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class UnknownFeatureType(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...

class FeatureType(_message.Message):
    __slots__ = ("text", "categorical", "primary_key", "foreign_key", "identifier", "numerical", "multi_categorical", "timestamp", "embedding", "unknown", "is_excluded")
    TEXT_FIELD_NUMBER: _ClassVar[int]
    CATEGORICAL_FIELD_NUMBER: _ClassVar[int]
    PRIMARY_KEY_FIELD_NUMBER: _ClassVar[int]
    FOREIGN_KEY_FIELD_NUMBER: _ClassVar[int]
    IDENTIFIER_FIELD_NUMBER: _ClassVar[int]
    NUMERICAL_FIELD_NUMBER: _ClassVar[int]
    MULTI_CATEGORICAL_FIELD_NUMBER: _ClassVar[int]
    TIMESTAMP_FIELD_NUMBER: _ClassVar[int]
    EMBEDDING_FIELD_NUMBER: _ClassVar[int]
    UNKNOWN_FIELD_NUMBER: _ClassVar[int]
    IS_EXCLUDED_FIELD_NUMBER: _ClassVar[int]
    text: TextFeatureType
    categorical: CategoricalFeatureType
    primary_key: PrimaryKeyFeatureType
    foreign_key: ForeignKeyFeatureType
    identifier: IdentifierFeatureType
    numerical: NumericalFeatureType
    multi_categorical: MultiCategoricalFeatureType
    timestamp: TimestampFeatureType
    embedding: EmbeddingFeatureType
    unknown: UnknownFeatureType
    is_excluded: bool
    def __init__(self, text: _Optional[_Union[TextFeatureType, _Mapping]] = ..., categorical: _Optional[_Union[CategoricalFeatureType, _Mapping]] = ..., primary_key: _Optional[_Union[PrimaryKeyFeatureType, _Mapping]] = ..., foreign_key: _Optional[_Union[ForeignKeyFeatureType, _Mapping]] = ..., identifier: _Optional[_Union[IdentifierFeatureType, _Mapping]] = ..., numerical: _Optional[_Union[NumericalFeatureType, _Mapping]] = ..., multi_categorical: _Optional[_Union[MultiCategoricalFeatureType, _Mapping]] = ..., timestamp: _Optional[_Union[TimestampFeatureType, _Mapping]] = ..., embedding: _Optional[_Union[EmbeddingFeatureType, _Mapping]] = ..., unknown: _Optional[_Union[UnknownFeatureType, _Mapping]] = ..., is_excluded: bool = ...) -> None: ...

class SelectFromStagingOp(_message.Message):
    __slots__ = ("blob_names", "columns", "expected_rows", "arrow_schema", "feature_types")
    BLOB_NAMES_FIELD_NUMBER: _ClassVar[int]
    COLUMNS_FIELD_NUMBER: _ClassVar[int]
    EXPECTED_ROWS_FIELD_NUMBER: _ClassVar[int]
    ARROW_SCHEMA_FIELD_NUMBER: _ClassVar[int]
    FEATURE_TYPES_FIELD_NUMBER: _ClassVar[int]
    blob_names: _containers.RepeatedScalarFieldContainer[str]
    columns: _containers.RepeatedScalarFieldContainer[str]
    expected_rows: int
    arrow_schema: bytes
    feature_types: _containers.RepeatedCompositeFieldContainer[FeatureType]
    def __init__(self, blob_names: _Optional[_Iterable[str]] = ..., columns: _Optional[_Iterable[str]] = ..., expected_rows: _Optional[int] = ..., arrow_schema: _Optional[bytes] = ..., feature_types: _Optional[_Iterable[_Union[FeatureType, _Mapping]]] = ...) -> None: ...

class SelectColumnsOp(_message.Message):
    __slots__ = ("source", "columns")
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    COLUMNS_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    columns: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., columns: _Optional[_Iterable[str]] = ...) -> None: ...

class LimitRowsOp(_message.Message):
    __slots__ = ("source", "num_rows")
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    NUM_ROWS_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    num_rows: int
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., num_rows: _Optional[int] = ...) -> None: ...

class FilterRowsOp(_message.Message):
    __slots__ = ("source", "row_filter")
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    ROW_FILTER_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    row_filter: RowFilter
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., row_filter: _Optional[_Union[RowFilter, _Mapping]] = ...) -> None: ...

class DistinctRowsOp(_message.Message):
    __slots__ = ("source",)
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ...) -> None: ...

class UpdateMetadataOp(_message.Message):
    __slots__ = ("source", "metadata_updates")
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    METADATA_UPDATES_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    metadata_updates: _struct_pb2.Struct
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., metadata_updates: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ...) -> None: ...

class SetMetadataOp(_message.Message):
    __slots__ = ("source", "new_metadata")
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    NEW_METADATA_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    new_metadata: _struct_pb2.Struct
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., new_metadata: _Optional[_Union[_struct_pb2.Struct, _Mapping]] = ...) -> None: ...

class RemoveFromMetadataOp(_message.Message):
    __slots__ = ("source", "keys_to_remove")
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    KEYS_TO_REMOVE_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    keys_to_remove: _containers.RepeatedScalarFieldContainer[str]
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., keys_to_remove: _Optional[_Iterable[str]] = ...) -> None: ...

class UpdateFeatureTypesOp(_message.Message):
    __slots__ = ("source", "new_feature_types")
    class NewFeatureTypesEntry(_message.Message):
        __slots__ = ("key", "value")
        KEY_FIELD_NUMBER: _ClassVar[int]
        VALUE_FIELD_NUMBER: _ClassVar[int]
        key: str
        value: FeatureType
        def __init__(self, key: _Optional[str] = ..., value: _Optional[_Union[FeatureType, _Mapping]] = ...) -> None: ...
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    NEW_FEATURE_TYPES_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    new_feature_types: _containers.MessageMap[str, FeatureType]
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., new_feature_types: _Optional[_Mapping[str, FeatureType]] = ...) -> None: ...

class RollupByAggregationOp(_message.Message):
    __slots__ = ("source", "group_by_column_names", "target_column_name", "aggregation_type")
    SOURCE_FIELD_NUMBER: _ClassVar[int]
    GROUP_BY_COLUMN_NAMES_FIELD_NUMBER: _ClassVar[int]
    TARGET_COLUMN_NAME_FIELD_NUMBER: _ClassVar[int]
    AGGREGATION_TYPE_FIELD_NUMBER: _ClassVar[int]
    source: TableComputeOp
    group_by_column_names: _containers.RepeatedScalarFieldContainer[str]
    target_column_name: str
    aggregation_type: AggregationType
    def __init__(self, source: _Optional[_Union[TableComputeOp, _Mapping]] = ..., group_by_column_names: _Optional[_Iterable[str]] = ..., target_column_name: _Optional[str] = ..., aggregation_type: _Optional[_Union[AggregationType, str]] = ...) -> None: ...

class CombineFiltersRowFilter(_message.Message):
    __slots__ = ("row_filters", "logical_combination")
    ROW_FILTERS_FIELD_NUMBER: _ClassVar[int]
    LOGICAL_COMBINATION_FIELD_NUMBER: _ClassVar[int]
    row_filters: _containers.RepeatedCompositeFieldContainer[RowFilter]
    logical_combination: LogicalCombination
    def __init__(self, row_filters: _Optional[_Iterable[_Union[RowFilter, _Mapping]]] = ..., logical_combination: _Optional[_Union[LogicalCombination, str]] = ...) -> None: ...

class CompareColumnToLiteralRowFilter(_message.Message):
    __slots__ = ("column_name", "literal", "comparison_type")
    COLUMN_NAME_FIELD_NUMBER: _ClassVar[int]
    LITERAL_FIELD_NUMBER: _ClassVar[int]
    COMPARISON_TYPE_FIELD_NUMBER: _ClassVar[int]
    column_name: str
    literal: _struct_pb2.Value
    comparison_type: ComparisonType
    def __init__(self, column_name: _Optional[str] = ..., literal: _Optional[_Union[_struct_pb2.Value, _Mapping]] = ..., comparison_type: _Optional[_Union[ComparisonType, str]] = ...) -> None: ...

class RowFilter(_message.Message):
    __slots__ = ("compare_column_to_literal", "combine_filters")
    COMPARE_COLUMN_TO_LITERAL_FIELD_NUMBER: _ClassVar[int]
    COMBINE_FILTERS_FIELD_NUMBER: _ClassVar[int]
    compare_column_to_literal: CompareColumnToLiteralRowFilter
    combine_filters: CombineFiltersRowFilter
    def __init__(self, compare_column_to_literal: _Optional[_Union[CompareColumnToLiteralRowFilter, _Mapping]] = ..., combine_filters: _Optional[_Union[CombineFiltersRowFilter, _Mapping]] = ...) -> None: ...

class EmptyOp(_message.Message):
    __slots__ = ()
    def __init__(self) -> None: ...
